/***************************************************************
Vse prava zashisheni :) avtor DEmoN  e-mail: tiger_85@bk.ru

Postroenie graphika funkcii y=exp(-x), s macshtabirovaniem,
v zadannih predelah.
****************************************************************
*/



#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <math.h>

// Funkciya perescheta argumenta v coordinatu ==============================
int icoord(int ir1, int ir2, double r1, double r2, double r)
{
  double rdel;	// delitel perexoda ot ir k r (mnojitel perexoda ot r k ir)

  if(r1==r2)
   return( ir1 ); // oshibka dannykh r
  rdel=(ir2-ir1)/(r2-r1);

  return( (int)(ir1+(r-r1)*rdel) );
}

// Funkciya postroeniya grafika exp(-x) =====================================
int drawexp(double x1g, double x2g,
	    int ix1, int ix2, int iy1, int iy2,
	    double rx1, double rx2, double ry1, double ry2, int color)
	    // Vnimanie: ix1<ix2
{
  double rmnjx;	// mnojitel perexoda ot ix k rx
  double rdely;	// delitel perexoda ot iy k ry (mnojitel perexoda ot ry k iy)
  int ii;
  double wrkx,wrky,wrky2;
  int iymn, iymx;
  int ix1g, ix2g;
  int badpoint;		// Priznak, chto predidyshaya tochka bila za predelami
			// 0 - v norme, >0 - iymx, <0 - iymn
  int iy;	// celochislennaia ekrannaya koordinata
  int oldcolor;

  if(ix1==ix2)
   return( -1 ); // oshibka dannykh x
  rmnjx=(rx2-rx1)/(ix2-ix1);

  if(ry1==ry2)
   return( -2 ); // oshibka dannykh y
  rdely=(iy2-iy1)/(ry2-ry1);

  ix1g = icoord(ix1,ix2,rx1,rx2,x1g);
  ix2g = icoord(ix1,ix2,rx1,rx2,x2g);

  if(iy1>iy2){
      iymx=iy1;
      iymn=iy2;
  }else{
      iymx=iy2;
      iymn=iy1;
  }

  oldcolor=getcolor();
  setcolor(color);

  for(ii=ix1g; ii<=ix2g; ii++){
      wrkx=rx1+(ii-ix1)*rmnjx;
      wrky=exp(-wrkx);
      wrky2=iy1+(wrky-ry1)*rdely;

      //Perevod v celie s zashitoi pereplneniya.

      if(wrky2>iymx+1)
       iy = iymx+1;
      else if(wrky2<iymn-1)
       iy = iymn-1;
      else
       iy = (int)wrky2;

      if(iy>iymx){
	    if(ii==ix1g){
		badpoint = 1;
	 }else
	    if(badpoint>0){
		;
	    }else{	//Risyu kysok ot posledney tochki do granici
		if(badpoint<0) moveto(ii-1,iymn);
		lineto(ii,iymx);
		badpoint = 1;
	    }
	    continue;
      }else
      if(iy<iymn){
	    if(ii==ix1g){
		badpoint = -1;
	   }else
	    if(badpoint<0){
		;
	    }else{
		if(badpoint>0) moveto(ii-1,iymx);
		lineto(ii,iymn);
		badpoint = -1;
	    }
	    continue;
      }

      if(ii==ix1g){
	moveto(ii,iy);
	badpoint = 0;
      }else{
	if(badpoint<0)
	  moveto(ii-1,iymn);
	else if(badpoint>0)
	  moveto(ii-1,iymx);
	lineto(ii,iy);
	badpoint = 0;
      }
  }

  if(ix1g==ix2g){
    if(badpoint==0)
      putpixel(ix2g,iy, color);
    if(badpoint<0)
      putpixel(ix2g,iymn, color);
    else if(badpoint>0)
      putpixel(ix2g,iymx, color);
  }

  setcolor(oldcolor);
  return( 0 );
}



// Funkciya postroeniya horiz osi ========================================
int drawaxex(int ix1, int ix2, int iy1, int iy2, int iy,
	    double rx1, double rx2,
	    double stepx)
{
  double rdelx;	// delitel perexoda ot ix k rx (mnojitel perexoda ot rx k ix)
  double wrkx1, wrkx2, wrkx;
  int i1, i2;
  int ii;
  char txt[100];  //20

  if(rx1==rx2) return( -1 ); // oshibka dannykh y

  rdelx=(ix2-ix1)/(rx2-rx1);

  setcolor(WHITE);	// cvet horizontal'noi osi koordinat============
  line(ix1, iy, ix2, iy);

  wrkx1=rx1/stepx;
  wrkx2=rx2/stepx;
  if(wrkx1>wrkx2){
      wrkx=wrkx1;
      wrkx1=wrkx2;
      wrkx2=wrkx;
  }

  i1=(int)floor(wrkx1);
    if(i1<wrkx1) i1++;
  i2=(int)floor(wrkx2)+1;
    if(i2<wrkx2) i2--;

// Risuem vertikalnyu setky ===============================================
//  setcolor(BROWN)
  setcolor(WHITE);

  for(ii=i1; ii<i2; ii++){
      wrkx=ii*stepx;
      wrkx=ix1+(wrkx-rx1)*rdelx;
      line((int)wrkx, iy1, (int)wrkx, iy2);
   }

// Pishem cifri na osyah ==================================================
  setcolor(GREEN);
  settextjustify(CENTER_TEXT, TOP_TEXT);
  for(ii=i1; ii<i2; ii++){
      wrkx=ii*stepx;

      sprintf(txt,stepx<1 || wrkx<=-9999999 || wrkx>=9999999 ? "%.1e" : "%.0f",wrkx);    //perevodit is chisla v <txt>
      wrkx=ix1+(wrkx-rx1)*rdelx;   //raspologenie na monitore
      outtextxy((int)wrkx, iy+3, txt);    //vivod texta na monitor
    }
  return( 0 );
}

// Funkciya postroeniya vertik osi==========================================
int drawaxey(int ix1, int ix2, int iy1, int iy2, int ix,
	    double ry1, double ry2,
	    double stepy)
{
  double rdely;	// delitel perexoda ot iy k ry (mnojitel perexoda ot ry k iy)
  double wrky1, wrky2, wrky;
  int i1, i2;
  int ii;
  char txt[100];  //20

  if(ry1==ry2) return( -1 ); // oshibka dannykh y
  rdely=(iy2-iy1)/(ry2-ry1);

  setcolor(WHITE);	// cvet vetrikal'noi osi koordinat============]
  //  setcolor(BROWN);
  line(ix, iy1, ix, iy2);
  wrky1=ry1/stepy;
  wrky2=ry2/stepy;
  if(wrky1>wrky2){
      wrky=wrky1;
      wrky1=wrky2;
      wrky2=wrky;
  }

  i1=(int)floor(wrky1);
    if(i1<wrky1) i1++;
  i2=(int)floor(wrky2)+1;
    if(i2<wrky2) i2--;


// Risuem gorizontalnyu setky ============================================
  setcolor(WHITE);
  //  setcolor(BROWN);
  for(ii=i1; ii<i2; ii++){
      wrky=ii*stepy;
      wrky=iy1+(wrky-ry1)*rdely;
      line(ix1, (int)wrky, ix2, (int)wrky);
   }

// Pishem cifri na osyah =================================================
  setcolor(GREEN);
  settextjustify(LEFT_TEXT,CENTER_TEXT);
  for(ii=i1; ii<i2; ii++){
      wrky=ii*stepy;
      sprintf(txt,stepy<1 || wrky<=-9999999 || wrky>=9999999 ? "%.1e" : "%.0f",wrky);    //perevodit is chisla v <txt>
      wrky=iy1+(wrky-ry1)*rdely;       //raspologenie na monitore
      outtextxy(ix+3,(int)wrky, txt);  //vivod texta na monitor
    }
  return( 0 );
}
  void swap(double *px,double *py)
   {
    double temp;
    temp= *px;
     *px= *py;
     *py=temp;
   }


//MAIN() ===============================================================
int main(void)
{
   int gdriver = DETECT, gmode, errorcode;  /*<DETECT>-avtoopredelenie */

   double x1,x2,y1,y2;	// interval argumenta i funktsii osej
   double x1g, x2g;	// interval argumenta risovki grafika
   float fx1, fx2;

   double zapasx,zapasy;

   int ix1,ix2,iy1,iy2;
   int ix0,iy0;
   double stepx,stepy;
   double wrk;
   char ch;

   double x1p;
   double x2p;
     printf("\n======================================================================\n");
     printf(" Programma postroeniya grafika funkcii y=exp(-x) na zadannom intervale\n");
     printf("======================================================================\n");
     printf("\n  Vvedite koordinati nachala i konca intervala, ispol'zuya klavishy ENTER...\n");


     //==============================================================
     // zashita
     for(;;){
       if(scanf("%f%f",&fx1,&fx2)!=2){
	      do{
		 scanf("%c",&ch);
	      }while(ch!='\n');
	      printf("Oshibka, povtorite vvod...\n");
	      continue;
      }
      do{
	 scanf("%c",&ch);
      }while(ch!='\n');
      break;
   }
    //=====   =======================================================

	     if (fx1>fx2){
	      if (fx2<0 || fx2>0)
		   x1p=fx1;
		   x2p=fx2;
		 swap(&x1p,&x2p);
		     fx1=x1p;
		     fx2=x2p;
		}

	   x1=fx1;
	   x2=fx2;
	   x1g=x1;
	   x2g=x2;
	   zapasx=1.1;
	   zapasy=1.1;

	   if(x1>0 && x2>0){
		 if(x1>x2){
		   if(0.5*x1<x2){
		       zapasy=1.2;
		       zapasx=1.5;
		   }
		   x2=0;

	       }else{
		   if(0.5*x2<x1){
		       zapasy=1.2;
		       zapasx=1.5;
		   }
			   x1=0;
		       }
	   }else if(x1<0 && x2<0){
	       if(x1<=x2){
		   if(0.5*x1>x2){
		       zapasy=1.2;
		       zapasx=1.5;
		   }
		   x2=0;
	      }else{
		   if(0.5*x2>x1){
		       zapasy=1.2;
		       zapasx=1.5;
		   }
		   x1=0;
	       }
	   }
	   if(x2-x1==0){
	       x2=1;
	       x1=0;
	   }

	   y1=0.0;
	   y2=exp(max(-x1g,-x2g));

	   x1 = x1*zapasx;
	   x2 = x2*zapasx;
	   y1 = y1*zapasy;
	   y2 = y2*zapasy;

//==========================================================================
   initgraph(&gdriver, &gmode,"");
/*funkciya perevoda komp'utera is textovogo v graficheskii regim */

/*void far initgraph(int far *gdriver,int far *gmode,char far *pathtodriver)
 <gdriver> opredeliaet, kakim driverom bydem pol'zovat'sya;
 ispol'zyem <DETECT>-avtoopredelenie(VGA);
 <gmode> opredeliaet graficheskii regim, opredeliyaetsya avtomatom (<DETECT>)
*/
   errorcode = graphresult(); /*polychem rezyl'tat ispolneniya initgraph*/
   if (errorcode != grOk)     /*ne OK - pisat' oshibka */
   {
      printf("Graphics error: %s\n", grapherrormsg(errorcode));
/*grapherrormsg(errorcode) rasshifrovivaet kod oshibki*/

      printf("Press any key to halt:");
      getch();                /*ogidaem nagatiya klavishi*/
      exit(1);                /*vihodim s kodom vihoda iz programmi <1>*/
   }
//==========================================================================

   ix1=getmaxx()/10;
   ix2=9*getmaxx()/10;
   iy1=19*getmaxy()/20;
   iy2=getmaxy()/20;

     iy0=icoord(iy1, iy2, y1, y2, 0.0);	// eto verno tol'ko pri y0=0.0 vnutri [y1,y2]
     ix0=icoord(ix1, ix2, x1, x2, 0.0);	// eto verno tol'ko pri x0=0.0 vnutri [x1,x2]

   setbkcolor(YELLOW);     //===================FON
   cleardevice();   /* clear the screen */

//Risuem gorizontal'nuju os'=============================================
     stepx=1.0;
     wrk = x1 - x2;
     if(wrk<0)
       wrk = -wrk;
     while(wrk/stepx>20)
       stepx=stepx*10;
     while(wrk/stepx<1)
       stepx=stepx/10;
     drawaxex(ix1, ix2, iy0-3, iy0+3, iy0, x1, x2, stepx);

//Risuem vertical'nuju os'===============================================
     stepy=1.0;
     wrk = y1 - y2;
     if(wrk<0)
      wrk = -wrk;
     while(wrk/stepy>30)
      stepy=stepy*10;
     while(wrk/stepy<1)
      stepy=stepy/10;

     drawaxey(ix0-3, ix0+3, iy1, iy2, ix0, y1, y2, stepy);

//Risuem grafik ==========================================================
     drawexp(x1g, x2g, ix1, ix2, iy1, iy2, x1, x2, y1, y2, BLUE);

// display the information ==============================================
     setcolor(RED);   //cvet nadpici
     settextjustify(CENTER_TEXT, CENTER_TEXT);
     outtextxy(getmaxx()/2, getmaxy()/40, "Y=exp(-x)");

     getch();
     closegraph(); /*perevod v textovii regim*/
     return 0;

}